package com.sztzjy.money_management.entity;

import java.math.BigDecimal;

import io.swagger.annotations.ApiModelProperty;
/**
 * 案例财务分析收支储蓄表
 *
 * @author xcj
 * case_income_and_expenses
 */
public class CaseIncomeAndExpenses {
    @ApiModelProperty("案例-财务分析-收支储蓄id")
    private String caseIncomeAndExpensesId;

    private String caseid;

    @ApiModelProperty("薪资收入")
    private BigDecimal jobIncome;

    @ApiModelProperty("养老保险储蓄")
    private BigDecimal endowmentInsurance;

    @ApiModelProperty("医疗保险储蓄")
    private BigDecimal medicalInsurance;

    @ApiModelProperty("住房公积金储蓄")
    private BigDecimal housingFund;

    @ApiModelProperty("其他工作收入")
    private BigDecimal otherJobIncome;

    @ApiModelProperty("家计支出")
    private BigDecimal familyExpense;

    @ApiModelProperty("子女教育支出")
    private BigDecimal childExpense;

    @ApiModelProperty("其他支出")
    private BigDecimal otherExpense;

    @ApiModelProperty("利息收入")
    private BigDecimal interest;

    @ApiModelProperty("资本利得")
    private BigDecimal capitalGains;

    @ApiModelProperty("其他理财收入")
    private BigDecimal otherIncome;

    @ApiModelProperty("利息支出")
    private BigDecimal interestExpense;

    @ApiModelProperty("保障型保费支出")
    private BigDecimal insuranceExpense;

    @ApiModelProperty("其他理财支出")
    private BigDecimal otherFinanceExpense;

    @ApiModelProperty("用户ID")
    private String userId;

    @ApiModelProperty("学生答案/题目答案")
    private String isAnswer;

    public String getCaseIncomeAndExpensesId() {
        return caseIncomeAndExpensesId;
    }

    public void setCaseIncomeAndExpensesId(String caseIncomeAndExpensesId) {
        this.caseIncomeAndExpensesId = caseIncomeAndExpensesId == null ? null : caseIncomeAndExpensesId.trim();
    }

    public String getCaseid() {
        return caseid;
    }

    public void setCaseid(String caseid) {
        this.caseid = caseid == null ? null : caseid.trim();
    }

    public BigDecimal getJobIncome() {
        return jobIncome;
    }

    public void setJobIncome(BigDecimal jobIncome) {
        this.jobIncome = jobIncome;
    }

    public BigDecimal getEndowmentInsurance() {
        return endowmentInsurance;
    }

    public void setEndowmentInsurance(BigDecimal endowmentInsurance) {
        this.endowmentInsurance = endowmentInsurance;
    }

    public BigDecimal getMedicalInsurance() {
        return medicalInsurance;
    }

    public void setMedicalInsurance(BigDecimal medicalInsurance) {
        this.medicalInsurance = medicalInsurance;
    }

    public BigDecimal getHousingFund() {
        return housingFund;
    }

    public void setHousingFund(BigDecimal housingFund) {
        this.housingFund = housingFund;
    }

    public BigDecimal getOtherJobIncome() {
        return otherJobIncome;
    }

    public void setOtherJobIncome(BigDecimal otherJobIncome) {
        this.otherJobIncome = otherJobIncome;
    }

    public BigDecimal getFamilyExpense() {
        return familyExpense;
    }

    public void setFamilyExpense(BigDecimal familyExpense) {
        this.familyExpense = familyExpense;
    }

    public BigDecimal getChildExpense() {
        return childExpense;
    }

    public void setChildExpense(BigDecimal childExpense) {
        this.childExpense = childExpense;
    }

    public BigDecimal getOtherExpense() {
        return otherExpense;
    }

    public void setOtherExpense(BigDecimal otherExpense) {
        this.otherExpense = otherExpense;
    }

    public BigDecimal getInterest() {
        return interest;
    }

    public void setInterest(BigDecimal interest) {
        this.interest = interest;
    }

    public BigDecimal getCapitalGains() {
        return capitalGains;
    }

    public void setCapitalGains(BigDecimal capitalGains) {
        this.capitalGains = capitalGains;
    }

    public BigDecimal getOtherIncome() {
        return otherIncome;
    }

    public void setOtherIncome(BigDecimal otherIncome) {
        this.otherIncome = otherIncome;
    }

    public BigDecimal getInterestExpense() {
        return interestExpense;
    }

    public void setInterestExpense(BigDecimal interestExpense) {
        this.interestExpense = interestExpense;
    }

    public BigDecimal getInsuranceExpense() {
        return insuranceExpense;
    }

    public void setInsuranceExpense(BigDecimal insuranceExpense) {
        this.insuranceExpense = insuranceExpense;
    }

    public BigDecimal getOtherFinanceExpense() {
        return otherFinanceExpense;
    }

    public void setOtherFinanceExpense(BigDecimal otherFinanceExpense) {
        this.otherFinanceExpense = otherFinanceExpense;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId == null ? null : userId.trim();
    }

    public String getIsAnswer() {
        return isAnswer;
    }

    public void setIsAnswer(String isAnswer) {
        this.isAnswer = isAnswer == null ? null : isAnswer.trim();
    }
}