package com.sztzjy.money_management.service.impl;

import cn.hutool.core.util.IdUtil;
import com.sztzjy.money_management.entity.*;
import com.sztzjy.money_management.mapper.*;
import com.sztzjy.money_management.service.SynthesisPlanService;
import com.sztzjy.money_management.util.ResultEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Author xcj
 * @Date 2024/8/16
 */
@Service
public class SynthesisPlanServiceImpl implements SynthesisPlanService {
    @Autowired
    private CaseInfoMapper caseInfoMapper;
    @Autowired
    private CaseCashPlanMapper caseCashPlanMapper;
    @Autowired
    private CaseLifeEducationPlanMapper caseLifeEducationPlanMapper;
    @Autowired
    private CaseStartAnUndertakingPlanMapper caseStartAnUndertakingPlanMapper;
    @Autowired
    private CaseRetirementPlanMapper caseRetirementPlanMapper;
    @Autowired
    private CaseInsurancePlanMapper caseInsurancePlanMapper;
    @Autowired
    private CaseTaxPlanMapper caseTaxPlanMapper;
    @Autowired
    private CaseDistributionOfPropertyMapper caseDistributionOfPropertyMapper;
    @Autowired
    private CaseHeritageMapper caseHeritageMapper;
    @Autowired
    private ComCaseMapper comCaseMapper;
    @Autowired
    private CaseRiskIndexMapper caseRiskIndexMapper;
    @Autowired
    private CaseFinanceLiabilityMapper caseFinanceLiabilityMapper;
    @Autowired
    private CaseIncomeAndExpensesMapper caseIncomeAndExpensesMapper;
    @Autowired
    private CaseCashFlowMapper caseCashFlowMapper;
    @Autowired
    private CaseFinancialRatiosMapper caseFinancialRatiosMapper;
    @Autowired
    private SynthesisPlanClientMapper synthesisPlanClientMapper;
    @Autowired
    private StuTrainingMapper stuTrainingMapper;
    @Autowired
    private CaseConsumptionPlanMapper caseConsumptionPlanMapper;
    @Autowired
    private CaseServiceImpl caseService;
    @Autowired
    private SynthesisPlanScoreMapper synthesisPlanScoreMapper;
    @Autowired
    private CaseInvestmentPlanMapper caseInvestmentPlanmapper;

    @Override
    public Map<String, String> adviseInvestmentProductAllot(BigDecimal RAIScore, BigDecimal RCIScore) {
        Map<String, String> allocation = new HashMap<>();

        int RAIScoreInt = RAIScore.intValue(); //风险容忍态度分数
        int RCIScoreInt = RCIScore.intValue();  //风险承受能力分数

        if (RAIScoreInt >= 0 && RAIScoreInt <= 19) {
            if (RCIScoreInt >= 0 && RCIScoreInt <= 19) {
                allocation.put("货币", "70%");
                allocation.put("债券", "20%");
                allocation.put("股票", "10%");
            }
            if (RCIScoreInt >= 20 && RCIScoreInt <= 39) {
                allocation.put("货币", "50%");
                allocation.put("债券", "40%");
                allocation.put("股票", "10%");
            }
            if (RCIScoreInt >= 40 && RCIScoreInt <= 59) {
                allocation.put("货币", "40%");
                allocation.put("债券", "40%");
                allocation.put("股票", "20%");
            }
            if (RCIScoreInt >= 60 && RCIScoreInt <= 79) {
                allocation.put("货币", "20%");
                allocation.put("债券", "50%");
                allocation.put("股票", "30%");
            }
            if (RCIScoreInt >= 80 && RCIScoreInt <= 100) {
                allocation.put("货币", "0%");
                allocation.put("债券", "50%");
                allocation.put("股票", "50%");
            }
        }

        if (RAIScoreInt >= 20 && RAIScoreInt <= 39) {
            if (RCIScoreInt >= 0 && RCIScoreInt <= 19) {
                allocation.put("货币", "50%");
                allocation.put("债券", "40%");
                allocation.put("股票", "10%");
            }
            if (RCIScoreInt >= 20 && RCIScoreInt <= 39) {
                allocation.put("货币", "40%");
                allocation.put("债券", "40%");
                allocation.put("股票", "20%");
            }
            if (RCIScoreInt >= 40 && RCIScoreInt <= 59) {
                allocation.put("货币", "20%");
                allocation.put("债券", "50%");
                allocation.put("股票", "30%");
            }
            if (RCIScoreInt >= 60 && RCIScoreInt <= 79) {
                allocation.put("货币", "0%");
                allocation.put("债券", "50%");
                allocation.put("股票", "50%");
            }
            if (RCIScoreInt >= 80 && RCIScoreInt <= 100) {
                allocation.put("货币", "0%");
                allocation.put("债券", "40%");
                allocation.put("股票", "60%");
            }
        }

        if (RAIScoreInt >= 40 && RAIScoreInt <= 59) {
            if (RCIScoreInt >= 0 && RCIScoreInt <= 19) {
                allocation.put("货币", "40%");
                allocation.put("债券", "40%");
                allocation.put("股票", "20%");
            }
            if (RCIScoreInt >= 20 && RCIScoreInt <= 39) {
                allocation.put("货币", "20%");
                allocation.put("债券", "50%");
                allocation.put("股票", "30%");
            }
            if (RCIScoreInt >= 40 && RCIScoreInt <= 59) {
                allocation.put("货币", "0%");
                allocation.put("债券", "50%");
                allocation.put("股票", "50%");
            }
            if (RCIScoreInt >= 60 && RCIScoreInt <= 79) {
                allocation.put("货币", "0%");
                allocation.put("债券", "40%");
                allocation.put("股票", "60%");
            }
            if (RCIScoreInt >= 80 && RCIScoreInt <= 100) {
                allocation.put("货币", "0%");
                allocation.put("债券", "30%");
                allocation.put("股票", "70%");
            }
        }

        if (RAIScoreInt >= 60 && RAIScoreInt <= 79) {
            if (RCIScoreInt >= 0 && RCIScoreInt <= 19) {
                allocation.put("货币", "20%");
                allocation.put("债券", "30%");
                allocation.put("股票", "50%");
            }
            if (RCIScoreInt >= 20 && RCIScoreInt <= 39) {
                allocation.put("货币", "0%");
                allocation.put("债券", "50%");
                allocation.put("股票", "50%");
            }
            if (RCIScoreInt >= 40 && RCIScoreInt <= 59) {
                allocation.put("货币", "0%");
                allocation.put("债券", "40%");
                allocation.put("股票", "60%");
            }
            if (RCIScoreInt >= 60 && RCIScoreInt <= 79) {
                allocation.put("货币", "0%");
                allocation.put("债券", "30%");
                allocation.put("股票", "70%");
            }
            if (RCIScoreInt >= 80 && RCIScoreInt <= 100) {
                allocation.put("货币", "0%");
                allocation.put("债券", "20%");
                allocation.put("股票", "80%");
            }
        }

        if (RAIScoreInt >= 80 && RAIScoreInt <= 100) {
            if (RCIScoreInt >= 0 && RCIScoreInt <= 19) {
                allocation.put("货币", "0%");
                allocation.put("债券", "50%");
                allocation.put("股票", "50%");
            }
            if (RCIScoreInt >= 20 && RCIScoreInt <= 39) {
                allocation.put("货币", "0%");
                allocation.put("债券", "40%");
                allocation.put("股票", "60%");
            }
            if (RCIScoreInt >= 40 && RCIScoreInt <= 59) {
                allocation.put("货币", "0%");
                allocation.put("债券", "30%");
                allocation.put("股票", "70%");
            }
            if (RCIScoreInt >= 60 && RCIScoreInt <= 79) {
                allocation.put("货币", "0%");
                allocation.put("债券", "20%");
                allocation.put("股票", "80%");
            }
            if (RCIScoreInt >= 80 && RCIScoreInt <= 100) {
                allocation.put("货币", "0%");
                allocation.put("债券", "10%");
                allocation.put("股票", "90%");
            }
        }
        return allocation;
    }

    @Override
    public ResultEntity<HttpStatus> getScore(String userId, String caseID) {
        CaseInfo caseInfo = caseInfoMapper.selectByPrimaryKey(caseID);
        List<String> typeList = new ArrayList<>();
        if ("综合规划".equals(caseInfo.getModel())) {
            ComCaseExample comCaseExample = new ComCaseExample();
            comCaseExample.createCriteria().andCaseidEqualTo(caseID);
            List<ComCase> comCaseList = comCaseMapper.selectByExample(comCaseExample);
            if (!comCaseList.isEmpty()) {
                ComCase comCase = comCaseList.get(0);
                String manageMoneyMattersType = comCase.getManageMoneyMattersType();
                String[] split = manageMoneyMattersType.split(",");
                typeList = Arrays.asList(split);
            }
        }

        //综合规划算分 学生客户信息是否填写正确
        SynthesisPlanClientExample synthesisPlanClientExample = new SynthesisPlanClientExample();
        synthesisPlanClientExample.createCriteria().andCaseidEqualTo(caseID).andUseridEqualTo(userId);
        List<SynthesisPlanClient> synthesisPlanClientList = synthesisPlanClientMapper.selectByExample(synthesisPlanClientExample);

        List<SynthesisPlanScoreWithBLOBs> list = new ArrayList<>();
        CaseInfo teaCaseInfo = caseInfoMapper.selectByPrimaryKey(caseID);

        // 如果客户信息列表为空，则返回错误
        if (synthesisPlanClientList == null || synthesisPlanClientList.isEmpty()) {
            return new ResultEntity<>(HttpStatus.BAD_REQUEST, "客户信息还未填写！");
        }
        //算分 添加成绩表
        synthesisPlanClient(userId, caseID, synthesisPlanClientList, list, teaCaseInfo);

        for (String type : typeList) {
            System.out.println(type);
            if (type.equals("风险测评-风险指标")) {
                //风险测评-风险指标
                CaseRiskIndexExample example = new CaseRiskIndexExample();
                example.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUseridIsNull();
                List<CaseRiskIndex> caseRiskIndices = caseRiskIndexMapper.selectByExample(example);

                CaseRiskIndexExample stuExample = new CaseRiskIndexExample();
                stuExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUseridEqualTo(userId);
                List<CaseRiskIndex> stuCaseRiskIndices = caseRiskIndexMapper.selectByExample(stuExample);

                //为空的话返回报错提示
                if (stuCaseRiskIndices == null || stuCaseRiskIndices.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseRiskIndex(userId, caseID, caseRiskIndices, stuCaseRiskIndices, list);
            }

            if (type.equals("财务分析-资产负债表")) {
                //财务分析-资产负债表
                CaseFinanceLiabilityExample caseFinanceLiabilityExample = new CaseFinanceLiabilityExample();
                caseFinanceLiabilityExample.createCriteria().andCaseIdEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseFinanceLiability> rightCaseFinanceLiabilities = caseFinanceLiabilityMapper.selectByExample(caseFinanceLiabilityExample);

                CaseFinanceLiabilityExample stuCaseFinanceLiabilityExample = new CaseFinanceLiabilityExample();
                stuCaseFinanceLiabilityExample.createCriteria().andCaseIdEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseFinanceLiability> stuCaseFinanceLiabilities = caseFinanceLiabilityMapper.selectByExample(stuCaseFinanceLiabilityExample);

                //为空的话返回报错提示
                if (stuCaseFinanceLiabilities == null || stuCaseFinanceLiabilities.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseFinanceLiabilities(userId, caseID, rightCaseFinanceLiabilities, stuCaseFinanceLiabilities, list);
            }

            if (type.equals("财务分析-收支储蓄表")) {
                //财务分析-收支储蓄表
                CaseIncomeAndExpensesExample caseIncomeAndExpensesExample = new CaseIncomeAndExpensesExample();
                caseIncomeAndExpensesExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseIncomeAndExpenses> rightCaseIncomeAndExpenses = caseIncomeAndExpensesMapper.selectByExample(caseIncomeAndExpensesExample);

                CaseIncomeAndExpensesExample stuCaseIncomeAndExpensesExample = new CaseIncomeAndExpensesExample();
                stuCaseIncomeAndExpensesExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseIncomeAndExpenses> stuCaseIncomeAndExpenses = caseIncomeAndExpensesMapper.selectByExample(stuCaseIncomeAndExpensesExample);

                //为空的话返回报错提示
                if (stuCaseIncomeAndExpenses == null || stuCaseIncomeAndExpenses.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseIncomeAndExpenses(userId, caseID, rightCaseIncomeAndExpenses, stuCaseIncomeAndExpenses, list);
            }

            if (type.equals("财务分析-现金流量表")) {
                //财务分析-现金流量表
                CaseCashFlowExample caseCashFlowExample = new CaseCashFlowExample();
                caseCashFlowExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseCashFlow> rightCashFlows = caseCashFlowMapper.selectByExample(caseCashFlowExample);

                CaseCashFlowExample stuCashFlowExample = new CaseCashFlowExample();
                stuCashFlowExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseCashFlow> stuCaseCashFlows = caseCashFlowMapper.selectByExample(stuCashFlowExample);

                //为空的话返回报错提示
                if (stuCaseCashFlows == null || stuCaseCashFlows.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                cashFlows(userId, caseID, rightCashFlows, stuCaseCashFlows, list);
            }

            if (type.equals("财务分析-财务比例分析")) {
                //财务分析-财务比例分析
                CaseFinancialRatiosExample caseFinancialRatiosExample = new CaseFinancialRatiosExample();
                caseFinancialRatiosExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseFinancialRatiosWithBLOBs> rightCaseFinancialRatiosWithBLOBs = caseFinancialRatiosMapper.selectByExampleWithBLOBs(caseFinancialRatiosExample);

                CaseFinancialRatiosExample stuCaseFinancialRatiosExample = new CaseFinancialRatiosExample();
                stuCaseFinancialRatiosExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseFinancialRatiosWithBLOBs> stuCaseFinancialRatiosWithBLOBs = caseFinancialRatiosMapper.selectByExampleWithBLOBs(stuCaseFinancialRatiosExample);

                //为空的话返回报错提示
                if (stuCaseFinancialRatiosWithBLOBs == null || stuCaseFinancialRatiosWithBLOBs.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseFinancialRatios(userId, caseID, rightCaseFinancialRatiosWithBLOBs, stuCaseFinancialRatiosWithBLOBs, list);
            }

            if (type.equals("现金规划")) {
                //现金规划
                CaseCashPlanExample caseCashPlanExample = new CaseCashPlanExample();
                caseCashPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseCashPlan> rightCaseCashPlans = caseCashPlanMapper.selectByExampleWithBLOBs(caseCashPlanExample);

                CaseCashPlanExample stuCaseCashPlanExample = new CaseCashPlanExample();
                stuCaseCashPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseCashPlan> stuCaseCashPlans = caseCashPlanMapper.selectByExampleWithBLOBs(stuCaseCashPlanExample);
                //为空的话返回报错提示
                if (stuCaseCashPlans == null || stuCaseCashPlans.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseCashPlans(userId, caseID, rightCaseCashPlans, stuCaseCashPlans, list);
            }

            if (type.equals("生涯规划-教育规划")) {
                //生涯规划-教育规划
                CaseLifeEducationPlanExample caseLifeEducationPlanExample = new CaseLifeEducationPlanExample();
                caseLifeEducationPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseLifeEducationPlan> rightCaseLifeEducationPlans = caseLifeEducationPlanMapper.selectByExampleWithBLOBs(caseLifeEducationPlanExample);

                CaseLifeEducationPlanExample stuCaseLifeEducationPlanExample = new CaseLifeEducationPlanExample();
                stuCaseLifeEducationPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseLifeEducationPlan> stuCaseLifeEducationPlans = caseLifeEducationPlanMapper.selectByExampleWithBLOBs(stuCaseLifeEducationPlanExample);
                //为空的话返回报错提示
                if (stuCaseLifeEducationPlans == null || stuCaseLifeEducationPlans.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseLifeEducationPlans(userId, caseID, rightCaseLifeEducationPlans, stuCaseLifeEducationPlans, list);
            }

            if (type.equals("生涯规划-消费规划")) {
                //生涯规划-消费规划
                CaseConsumptionPlanExample caseConsumptionPlanExample = new CaseConsumptionPlanExample();
                caseConsumptionPlanExample.createCriteria().andCaseIdEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseConsumptionPlan> rightCaseConsumptionPlans = caseConsumptionPlanMapper.selectByExampleWithBLOBs(caseConsumptionPlanExample);

                CaseConsumptionPlanExample stuCaseConsumptionPlanExample = new CaseConsumptionPlanExample();
                stuCaseConsumptionPlanExample.createCriteria().andCaseIdEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseConsumptionPlan> stuCaseConsumptionPlans = caseConsumptionPlanMapper.selectByExampleWithBLOBs(stuCaseConsumptionPlanExample);
                //为空的话返回报错提示
                if (stuCaseConsumptionPlans == null || stuCaseConsumptionPlans.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseConsumptionPlans(userId, caseID, rightCaseConsumptionPlans, stuCaseConsumptionPlans, list);
            }

            if (type.equals("生涯规划-创业规划")) {
                //生涯规划-创业规划
                CaseStartAnUndertakingPlanExample caseStartAnUndertakingPlanExample = new CaseStartAnUndertakingPlanExample();
                caseStartAnUndertakingPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseStartAnUndertakingPlan> rightCaseStartAnUndertakingPlans = caseStartAnUndertakingPlanMapper.selectByExampleWithBLOBs(caseStartAnUndertakingPlanExample);

                CaseStartAnUndertakingPlanExample stuCaseStartAnUndertakingPlanExample = new CaseStartAnUndertakingPlanExample();
                stuCaseStartAnUndertakingPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseStartAnUndertakingPlan> stuCaseStartAnUndertakingPlans = caseStartAnUndertakingPlanMapper.selectByExampleWithBLOBs(stuCaseStartAnUndertakingPlanExample);
                //为空的话返回报错提示
                if (stuCaseStartAnUndertakingPlans == null || stuCaseStartAnUndertakingPlans.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseStartAnUndertakingPlans(userId, caseID, rightCaseStartAnUndertakingPlans, stuCaseStartAnUndertakingPlans, list);
            }

            if (type.equals("生涯规划-退休规划")) {
                //生涯规划-退休规划
                CaseRetirementPlanExample caseRetirementPlanExample = new CaseRetirementPlanExample();
                caseRetirementPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseRetirementPlan> rightCaseRetirementPlans = caseRetirementPlanMapper.selectByExampleWithBLOBs(caseRetirementPlanExample);

                CaseRetirementPlanExample stuCaseRetirementPlanExample = new CaseRetirementPlanExample();
                stuCaseRetirementPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseRetirementPlan> stuCaseRetirementPlans = caseRetirementPlanMapper.selectByExampleWithBLOBs(stuCaseRetirementPlanExample);
                //为空的话返回报错提示
                if (stuCaseRetirementPlans == null || stuCaseRetirementPlans.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseRetirementPlans(userId, caseID, rightCaseRetirementPlans, stuCaseRetirementPlans, list);
            }

            if (type.equals("生涯规划-保险规划")) {
                //生涯规划-保险规划
                CaseInsurancePlanExample caseInsurancePlanExample = new CaseInsurancePlanExample();
                caseInsurancePlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseInsurancePlan> rightCaseInsurancePlans = caseInsurancePlanMapper.selectByExampleWithBLOBs(caseInsurancePlanExample);

                CaseInsurancePlanExample stuCaseInsurancePlanExample = new CaseInsurancePlanExample();
                stuCaseInsurancePlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseInsurancePlan> stuCaseInsurancePlans = caseInsurancePlanMapper.selectByExampleWithBLOBs(stuCaseInsurancePlanExample);
                //为空的话返回报错提示
                if (stuCaseInsurancePlans == null || stuCaseInsurancePlans.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseInsurancePlans(userId, caseID, rightCaseInsurancePlans, stuCaseInsurancePlans, list);
            }

            if (type.equals("投资规划")) {
                //投资规划
                CaseInvestmentPlanExample caseInvestmentPlanExample = new CaseInvestmentPlanExample();
                caseInvestmentPlanExample.createCriteria().andCaseIdEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseInvestmentPlan> rightCaseInvestmentPlans = caseInvestmentPlanmapper.selectByExample(caseInvestmentPlanExample);

                CaseInvestmentPlanExample stuCaseInvestmentPlanExample = new CaseInvestmentPlanExample();
                stuCaseInvestmentPlanExample.createCriteria().andCaseIdEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseInvestmentPlan> stuCaseInvestmentPlans = caseInvestmentPlanmapper.selectByExample(stuCaseInvestmentPlanExample);
                //为空的话返回报错提示
                if (stuCaseInvestmentPlans == null || stuCaseInvestmentPlans.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseInvestmentPlan(userId, caseID, rightCaseInvestmentPlans, stuCaseInvestmentPlans, list);
            }

            if (type.equals("税务筹划")) {
                //税务筹划
                CaseTaxPlanExample caseTaxPlanExample = new CaseTaxPlanExample();
                caseTaxPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseTaxPlan> rightCaseTaxPlans = caseTaxPlanMapper.selectByExampleWithBLOBs(caseTaxPlanExample);

                CaseTaxPlanExample stuCaseTaxPlanExample = new CaseTaxPlanExample();
                stuCaseTaxPlanExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseTaxPlan> stuCaseTaxPlans = caseTaxPlanMapper.selectByExampleWithBLOBs(stuCaseTaxPlanExample);
                //为空的话返回报错提示
                if (stuCaseTaxPlans == null || stuCaseTaxPlans.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseTaxPlans(userId, caseID, rightCaseTaxPlans, stuCaseTaxPlans, list);
            }

            if (type.equals("财产分配")) {
                //财产分配
                CaseDistributionOfPropertyExample caseDistributionOfPropertyExample = new CaseDistributionOfPropertyExample();
                caseDistributionOfPropertyExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseDistributionOfPropertyWithBLOBs> rightCaseDistributionOfPropertyWithBLOBs = caseDistributionOfPropertyMapper.selectByExampleWithBLOBs(caseDistributionOfPropertyExample);

                CaseDistributionOfPropertyExample stuCaseDistributionOfPropertyExample = new CaseDistributionOfPropertyExample();
                stuCaseDistributionOfPropertyExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseDistributionOfPropertyWithBLOBs> stuCaseDistributionOfPropertyWithBLOBs = caseDistributionOfPropertyMapper.selectByExampleWithBLOBs(stuCaseDistributionOfPropertyExample);

                //为空的话返回报错提示
                if (stuCaseDistributionOfPropertyWithBLOBs == null || stuCaseDistributionOfPropertyWithBLOBs.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseDistributionOfProperty(userId, caseID, rightCaseDistributionOfPropertyWithBLOBs, stuCaseDistributionOfPropertyWithBLOBs, list);
            }

            if (type.equals("财产传承")) {
                //财产传承
                CaseHeritageExample caseHeritageExample = new CaseHeritageExample();
                caseHeritageExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("题目答案").andUserIdIsNull();
                List<CaseHeritageWithBLOBs> rightCaseHeritageWithBLOBs = caseHeritageMapper.selectByExampleWithBLOBs(caseHeritageExample);

                CaseHeritageExample stuCaseHeritageExample = new CaseHeritageExample();
                stuCaseHeritageExample.createCriteria().andCaseidEqualTo(caseID).andIsAnswerEqualTo("学生答案").andUserIdEqualTo(userId);
                List<CaseHeritageWithBLOBs> stuCaseHeritageWithBLOBs = caseHeritageMapper.selectByExampleWithBLOBs(stuCaseHeritageExample);

                //为空的话返回报错提示
                if (stuCaseHeritageWithBLOBs == null || stuCaseHeritageWithBLOBs.isEmpty()) {
                    return new ResultEntity<HttpStatus>(HttpStatus.BAD_REQUEST, type + "还未填写！");
                }
                //计算对错
                caseHeritageWithBLOBs(userId, caseID, rightCaseHeritageWithBLOBs, stuCaseHeritageWithBLOBs, list);
            }
        }
        int i = synthesisPlanScoreMapper.batchInsert(list);
        if (i <= 0) {
            throw new RuntimeException("新增失败");
        }
        return new ResultEntity<HttpStatus>(HttpStatus.OK, "");
    }

    private void synthesisPlanClient(String userId, String caseID, List<SynthesisPlanClient> synthesisPlanClientList, List<SynthesisPlanScoreWithBLOBs> list, CaseInfo teaCaseInfo) {
        // 取出客户信息
        SynthesisPlanClient synthesisPlanClient = synthesisPlanClientList.get(0);
        Integer age = teaCaseInfo.getAge();
        String idCard = teaCaseInfo.getIdCard();
        String customerName = teaCaseInfo.getCustomerName();

        // 定义一个信息数组，用于存储需要验证的信息
        String[] fields = {"年龄", "姓名", "证件号码"};
        String[] values = {synthesisPlanClient.getAge() != null ? synthesisPlanClient.getAge().toString() : null,
                synthesisPlanClient.getIdcard(),
                synthesisPlanClient.getName()};

        // 定义对应的正确答案
        Object[] correctAnswers = {age, idCard, customerName};

        // 循环处理每个字段
        for (int i = 0; i < fields.length; i++) {
            SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
            synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
            synthesisPlanScore.setUserid(userId);
            synthesisPlanScore.setCaseid(caseID);
            synthesisPlanScore.setTestCenter(fields[i]);
            synthesisPlanScore.setManageMoneyMattersType("客户信息");
            synthesisPlanScore.setCaseAnswer(correctAnswers[i].toString());
            synthesisPlanScore.setStuAnswer(values[i]);

            if (values[i] == null || !Objects.equals(values[i], correctAnswers[i].toString())) {
                synthesisPlanScore.setStatus("答错");
                synthesisPlanScore.setScore(BigDecimal.ZERO);
            } else {
                synthesisPlanScore.setStatus("答对");
                synthesisPlanScore.setScore(BigDecimal.valueOf(2));
            }
            list.add(synthesisPlanScore);
        }
    }


    private void caseHeritageWithBLOBs(String userId, String
            caseID, List<CaseHeritageWithBLOBs> rightCaseHeritageWithBLOBs,
                                       List<CaseHeritageWithBLOBs> stuCaseHeritageWithBLOBs, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseHeritageWithBLOBs != null && !rightCaseHeritageWithBLOBs.isEmpty())
                && (stuCaseHeritageWithBLOBs != null && !stuCaseHeritageWithBLOBs.isEmpty())) {
            CaseHeritageWithBLOBs stuCaseHeritageWithBLOB = stuCaseHeritageWithBLOBs.get(0);
            CaseHeritageWithBLOBs caseHeritageWithBLOB = rightCaseHeritageWithBLOBs.get(0);

            Map<String, java.util.function.Function<CaseHeritageWithBLOBs, String>> testCenters = new HashMap<>();
            testCenters.put("现金", item -> convertToString(item.getCash()));
            testCenters.put("银行存款", item -> convertToString(item.getDeposit()));
            testCenters.put("人寿保单赔偿金额", item -> convertToString(item.getLifeInsurance()));
            testCenters.put("其他现金账户", item -> convertToString(item.getOtherCashAccount()));
            testCenters.put("股票", item -> convertToString(item.getStock()));
            testCenters.put("债券", item -> convertToString(item.getBond()));
            testCenters.put("基金", item -> convertToString(item.getFund()));
            testCenters.put("其他投资收益", item -> convertToString(item.getOtherInvestment()));
            testCenters.put("养老金（一次性收入现值）", item -> convertToString(item.getPension()));
            testCenters.put("配偶/遗孤年金收益（现值）", item -> convertToString(item.getAnnuityRevenue()));
            testCenters.put("其他退休基金", item -> convertToString(item.getOtherPension()));
            testCenters.put("房产", item -> convertToString(item.getHouse()));
            testCenters.put("汽车", item -> convertToString(item.getCar()));
            testCenters.put("其他个人资产", item -> convertToString(item.getOther()));
            testCenters.put("其他资产", item -> convertToString(item.getOtherProperty()));
            testCenters.put("短期贷款", item -> convertToString(item.getShortTermLoan()));
            testCenters.put("中期贷款", item -> convertToString(item.getMediumTermLoans()));
            testCenters.put("长期贷款", item -> convertToString(item.getLongTermLoan()));
            testCenters.put("其他贷款", item -> convertToString(item.getOtherLoan()));
            testCenters.put("临终医疗费用", item -> convertToString(item.getMedicalCosts()));
            testCenters.put("预期收入纳税额支出", item -> convertToString(item.getTaxCosts()));
            testCenters.put("丧葬费用", item -> convertToString(item.getFuneralExpenses()));
            testCenters.put("遗产处理费用", item -> convertToString(item.getHeritageCosts()));
            testCenters.put("其他费用", item -> convertToString(item.getOtherCosts()));
            testCenters.put("其他负债", item -> convertToString(item.getOtherLiabilities()));
            testCenters.put("财务分析", CaseHeritageWithBLOBs::getFinanceAnalysis);
            testCenters.put("财产传承规划分析", CaseHeritageWithBLOBs::getPlanAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseHeritageWithBLOBs, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseHeritageWithBLOBs, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseHeritageWithBLOB));
                String stuScore = convertToString(scoreGetter.apply(stuCaseHeritageWithBLOB));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("财产传承");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);
                if (testCenter.equals("财产传承规划分析") || testCenter.equals("财务分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }
    }

    private void caseDistributionOfProperty(String userId, String caseID,
                                            List<CaseDistributionOfPropertyWithBLOBs> rightCaseDistributionOfPropertys,
                                            List<CaseDistributionOfPropertyWithBLOBs> stuCaseDistributionOfPropertys,
                                            List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseDistributionOfPropertys != null && !rightCaseDistributionOfPropertys.isEmpty())
                && (stuCaseDistributionOfPropertys != null && !stuCaseDistributionOfPropertys.isEmpty())) {
            CaseDistributionOfPropertyWithBLOBs stuCaseDistributionOfProperty = stuCaseDistributionOfPropertys.get(0);
            CaseDistributionOfPropertyWithBLOBs caseDistributionOfProperty = rightCaseDistributionOfPropertys.get(0);

            Map<String, java.util.function.Function<CaseDistributionOfPropertyWithBLOBs, String>> testCenters = new HashMap<>();
            testCenters.put("婚姻、财产状况分析", CaseDistributionOfPropertyWithBLOBs::getSituationAnalysis);
            testCenters.put("财产分配规划分析", CaseDistributionOfPropertyWithBLOBs::getPlanAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseDistributionOfPropertyWithBLOBs, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseDistributionOfPropertyWithBLOBs, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseDistributionOfProperty));
                String stuScore = convertToString(scoreGetter.apply(stuCaseDistributionOfProperty));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("财产分配");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                list.add(synthesisPlanScore);
            }
        }

    }

    private void caseTaxPlans(String userId, String caseID, List<CaseTaxPlan> rightCaseTaxPlans,
                              List<CaseTaxPlan> stuCaseTaxPlans, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseTaxPlans != null && !rightCaseTaxPlans.isEmpty())
                && (stuCaseTaxPlans != null && !stuCaseTaxPlans.isEmpty())) {
            CaseTaxPlan stuCaseTaxPlan = stuCaseTaxPlans.get(0);
            CaseTaxPlan caseTaxPlan = rightCaseTaxPlans.get(0);

            Map<String, java.util.function.Function<CaseTaxPlan, String>> testCenters = new HashMap<>();
            testCenters.put("工资、薪金所得", item -> convertToString(item.getSalary()));
            testCenters.put("个体工商户的生产、经营所得", item -> convertToString(item.getOperatingRevenue()));
            testCenters.put("对企事业单位承包、承租经营所得", item -> convertToString(item.getEnterprisesRevenue()));
            testCenters.put("劳务报酬所得", item -> convertToString(item.getServiceIncome()));
            testCenters.put("稿酬所得", item -> convertToString(item.getRemuneration()));
            testCenters.put("特许权使用费所得", item -> convertToString(item.getLoyalities()));
            testCenters.put("财产转让所得", item -> convertToString(item.getDemise()));
            testCenters.put("偶然所得", item -> convertToString(item.getIncidentalIncome()));
            testCenters.put("利息、红利、股利所得", item -> convertToString(item.getInterest()));
            testCenters.put("税务筹划分析", CaseTaxPlan::getAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseTaxPlan, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseTaxPlan, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseTaxPlan));
                String stuScore = convertToString(scoreGetter.apply(stuCaseTaxPlan));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("税务筹划");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (testCenter.equals("税务筹划分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }

    }


    //投资规划
    private void caseInvestmentPlan(String userId, String
            caseID, List<CaseInvestmentPlan> rightCaseInvestmentPlans,
                                    List<CaseInvestmentPlan> stuCaseInvestmentPlans, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseInvestmentPlans != null && !rightCaseInvestmentPlans.isEmpty())
                && (stuCaseInvestmentPlans != null && !stuCaseInvestmentPlans.isEmpty())) {
            CaseInvestmentPlan stuCaseInvestmentPlan = stuCaseInvestmentPlans.get(0);
            CaseInvestmentPlan caseInvestmentPlan = rightCaseInvestmentPlans.get(0);

            Map<String, java.util.function.Function<CaseInvestmentPlan, String>> testCenters = new HashMap<>();
            testCenters.put("当前客户所处家庭生命周期", item -> convertToString(item.getLifeCycleId()));
            testCenters.put("投资规划分析", item -> convertToString(item.getAnalysis()));

            for (Map.Entry<String, java.util.function.Function<CaseInvestmentPlan, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseInvestmentPlan, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseInvestmentPlan));
                String stuScore = convertToString(scoreGetter.apply(stuCaseInvestmentPlan));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("投资规划");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (testCenter.equals("投资规划分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }
    }


    private void caseInsurancePlans(String userId, String
            caseID, List<CaseInsurancePlan> rightCaseInsurancePlans,
                                    List<CaseInsurancePlan> stuCaseInsurancePlans, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseInsurancePlans != null && !rightCaseInsurancePlans.isEmpty())
                && (stuCaseInsurancePlans != null && !stuCaseInsurancePlans.isEmpty())) {
            CaseInsurancePlan stuCaseInsurancePlan = stuCaseInsurancePlans.get(0);
            CaseInsurancePlan caseInsurancePlan = rightCaseInsurancePlans.get(0);

            Map<String, java.util.function.Function<CaseInsurancePlan, String>> testCenters = new HashMap<>();

            //学生只能选择一种方式提交
            if (stuCaseInsurancePlan.getMethodTypeId().equals("遗嘱需求法")) {
                //b客户,c配偶
                testCenters.put("寿险需求测算方法选择-遗属需求法-弥补遗属需求的寿险需求-姓名-配偶", item -> convertToString(item.getSpouseName()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-被保险人年龄-配偶", item -> convertToString(item.getAgec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-预计退休年龄-客户", item -> convertToString(item.getRetirementAgeb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-预计退休年龄-配偶", item -> convertToString(item.getRetirementAgec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-投资报酬率-客户", item -> convertToString(item.getReturnOnInvestmentb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-投资报酬率-配偶", item -> convertToString(item.getReturnOnInvestmentc()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-通货膨胀率-客户", item -> convertToString(item.getInflationRateb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-通货膨胀率-配偶", item -> convertToString(item.getInflationRatec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-收入增长率-客户", item -> convertToString(item.getRevenueGrowthb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-收入增长率-配偶", item -> convertToString(item.getRevenueGrowthc()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-当前的家庭生活费用-客户", item -> convertToString(item.getMatrimonialFeeb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-当前的家庭生活费用-配偶", item -> convertToString(item.getMatrimonialFeec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-保险事故发生后支出调整率-客户", item -> convertToString(item.getAfterAccidentRateb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-保险事故发生后支出调整率-配偶", item -> convertToString(item.getAfterAccidentRatec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-配偶的个人年收入-客户", item -> convertToString(item.getIncomeb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-配偶的个人年收入-配偶", item -> convertToString(item.getIncomec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-临终及丧葬支出现值-客户", item -> convertToString(item.getDeathExpenseb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-临终及丧葬支出现值-配偶", item -> convertToString(item.getDeathExpensec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-目前贷款余额-客户", item -> convertToString(item.getLoanBalanceb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-目前贷款余额-配偶", item -> convertToString(item.getLoanBalancec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-家庭生息资产-客户", item -> convertToString(item.getEarningAssetsb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-家庭生息资产-配偶", item -> convertToString(item.getEarningAssetsc()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-已有额度-客户", item -> convertToString(item.getInsuranceAmountb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-已有额度-配偶", item -> convertToString(item.getInsuranceAmountc()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-预算金额-客户", item -> convertToString(item.getBudgetAmountb()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-预算金额-配偶", item -> convertToString(item.getLoanBalancec()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-补充额度-客户", item -> convertToString(item.getSupplementaryQuotab()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-补充额度-配偶", item -> convertToString(item.getSupplementaryQuotac()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-保险规划分析", CaseInsurancePlan::getAnalysis);
            } else {
                testCenters.put("寿险需求测算方法选择-生命价值法-预计退休年龄", item -> convertToString(item.getRetirementAgeb()));
                testCenters.put("寿险需求测算方法选择-生命价值法-投资报酬率", item -> convertToString(item.getReturnOnInvestmentb()));
                testCenters.put("寿险需求测算方法选择-生命价值法-当前个人年收入", item -> convertToString(item.getIncomeb()));
                testCenters.put("寿险需求测算方法选择-生命价值法-收入增长率", item -> convertToString(item.getRevenueGrowthb()));
                testCenters.put("寿险需求测算方法选择-生命价值法-当前个人年支出", item -> convertToString(item.getExpenditure()));
                testCenters.put("寿险需求测算方法选择-生命价值法-年通货膨胀率", item -> convertToString(item.getInflationRateb()));
                testCenters.put("寿险需求测算方法选择-生命价值法-已有额度", item -> convertToString(item.getInsuranceAmountb()));
                testCenters.put("寿险需求测算方法选择-生命价值法-预算金额", item -> convertToString(item.getBudgetAmountb()));
                testCenters.put("寿险需求测算方法选择-生命价值法-补充额度", item -> convertToString(item.getSupplementaryQuotab()));
                testCenters.put("寿险需求测算方法选择-遗属需求法-保险规划分析", CaseInsurancePlan::getAnalysis);
            }

            for (Map.Entry<String, java.util.function.Function<CaseInsurancePlan, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseInsurancePlan, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseInsurancePlan));
                String stuScore = convertToString(scoreGetter.apply(stuCaseInsurancePlan));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("生涯规划-保险规划");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (testCenter.equals("寿险需求测算方法选择-遗属需求法-保险规划分析")
                        || testCenter.equals("寿险需求测算方法选择-生命价值法-保险规划分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }
    }

    private void caseRetirementPlans(String userId, String
            caseID, List<CaseRetirementPlan> rightCaseRetirementPlans,
                                     List<CaseRetirementPlan> stuCaseRetirementPlans, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseRetirementPlans != null && !rightCaseRetirementPlans.isEmpty())
                && (stuCaseRetirementPlans != null && !stuCaseRetirementPlans.isEmpty())) {
            CaseRetirementPlan stuCaseRetirementPlan = stuCaseRetirementPlans.get(0);
            CaseRetirementPlan caseRetirementPlan = rightCaseRetirementPlans.get(0);

            Map<String, java.util.function.Function<CaseRetirementPlan, String>> testCenters = new HashMap<>();
            testCenters.put("退休前通货膨胀率", item -> convertToString(item.getBeforeInflationRate()));
            testCenters.put("退休后通货膨胀率", item -> convertToString(item.getAfterInflationRate()));
            testCenters.put("退休后投资收益率", item -> convertToString(item.getRetirementRate()));
            testCenters.put("计划退休年龄", item -> convertToString(item.getRetirementAge()));
            testCenters.put("希望享有的退休生活年限", item -> convertToString(item.getRetirementYears()));
            testCenters.put("目前生活水平", item -> convertToString(item.getLivingStandardNow()));
            testCenters.put("生活满意度", item -> convertToString(item.getSatisfaction()));
            testCenters.put("退休后、退休前生活水平折算比例", item -> convertToString(item.getConvertProportion()));
            testCenters.put("子女传承费用", item -> convertToString(item.getLineageFee()));
            testCenters.put("社会保险", item -> convertToString(item.getSocialInsurance()));
            testCenters.put("商业保险", item -> convertToString(item.getCommercialInsurance()));
            testCenters.put("租金收入", item -> convertToString(item.getRentIncome()));
            testCenters.put("其他收入", item -> convertToString(item.getOtherIncome()));
            testCenters.put("理财方案", item -> convertToString(item.getFinancialPlan()));
            testCenters.put("退休规划分析", CaseRetirementPlan::getAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseRetirementPlan, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseRetirementPlan, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseRetirementPlan));
                String stuScore = convertToString(scoreGetter.apply(stuCaseRetirementPlan));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("生涯规划-退休规划");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (testCenter.equals("理财方案") || testCenter.equals("退休规划分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }
    }

    private void caseStartAnUndertakingPlans(String userId, String
            caseID, List<CaseStartAnUndertakingPlan> rightCaseStartAnUndertakingPlans,
                                             List<CaseStartAnUndertakingPlan> stuCaseStartAnUndertakingPlans, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseStartAnUndertakingPlans != null && !rightCaseStartAnUndertakingPlans.isEmpty())
                && (stuCaseStartAnUndertakingPlans != null && !stuCaseStartAnUndertakingPlans.isEmpty())) {
            CaseStartAnUndertakingPlan stuCaseStartAnUndertakingPlan = stuCaseStartAnUndertakingPlans.get(0);
            CaseStartAnUndertakingPlan caseStartAnUndertakingPlan = rightCaseStartAnUndertakingPlans.get(0);

            Map<String, java.util.function.Function<CaseStartAnUndertakingPlan, String>> testCenters = new HashMap<>();
            testCenters.put("计划创业年龄", item -> convertToString(item.getStartPlanAge()));
            testCenters.put("创业时一次性投入", item -> convertToString(item.getCostInput()));
            testCenters.put("理财方案", item -> convertToString(item.getFinancialPlan()));
            testCenters.put("创业规划分析", CaseStartAnUndertakingPlan::getAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseStartAnUndertakingPlan, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseStartAnUndertakingPlan, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseStartAnUndertakingPlan));
                String stuScore = convertToString(scoreGetter.apply(stuCaseStartAnUndertakingPlan));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("生涯规划-创业规划");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (testCenter.equals("理财方案") || testCenter.equals("创业规划分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }
    }

    private void caseConsumptionPlans(String userId, String
            caseID, List<CaseConsumptionPlan> rightCaseConsumptionPlans,
                                      List<CaseConsumptionPlan> stuCaseConsumptionPlans, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseConsumptionPlans != null && !rightCaseConsumptionPlans.isEmpty())
                && (stuCaseConsumptionPlans != null && !stuCaseConsumptionPlans.isEmpty())) {
            CaseConsumptionPlan stuCaseConsumptionPlan = stuCaseConsumptionPlans.get(0);
            CaseConsumptionPlan caseConsumptionPlan = rightCaseConsumptionPlans.get(0);

            Map<String, java.util.function.Function<CaseConsumptionPlan, String>> testCenters = new HashMap<>();
            testCenters.put("消费目标-购房-距离购房年限", item -> convertToString(item.getShopHouseYear()));
            testCenters.put("消费目标-购房-总金额", item -> convertToString(item.getHouseAllMoney()));
            testCenters.put("消费目标-购房-首付比例", item -> convertToString(item.getHouseDownPaymentPercent()));
            testCenters.put("消费目标-购房-贷款年限", item -> convertToString(item.getHouseLoanYear()));
            testCenters.put("消费目标-购房-贷款利率", item -> convertToString(item.getHouseLoanRate()));
            testCenters.put("消费目标-购车-距离购车年限", item -> convertToString(item.getShopCarYear()));
            testCenters.put("消费目标-购车-预计裸车价格", item -> convertToString(item.getCarPrice()));
            testCenters.put("消费目标-购车-首付比例", item -> convertToString(item.getCarDownPaymentPercent()));
            testCenters.put("消费目标-购车-贷款年限", item -> convertToString(item.getCarLoanYear()));
            testCenters.put("消费目标-购车-贷款利率", item -> convertToString(item.getCarLoanRate()));
            testCenters.put("消费目标-购车-上牌费用", item -> convertToString(item.getCarRegFee()));
            testCenters.put("消费目标-购车-车船使用税", item -> convertToString(item.getVehicleAndVesselTax()));
            testCenters.put("消费目标-购车-商业保险", item -> convertToString(item.getMotorVehicleCommercial()));
            testCenters.put("理财方案", item -> convertToString(item.getFinancialPlan()));
            testCenters.put("消费规划分析", CaseConsumptionPlan::getAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseConsumptionPlan, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseConsumptionPlan, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseConsumptionPlan));
                String stuScore = convertToString(scoreGetter.apply(stuCaseConsumptionPlan));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("生涯规划-消费规划");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (testCenter.equals("理财方案") || testCenter.equals("消费规划分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }
    }

    private void caseLifeEducationPlans(String userId, String
            caseID, List<CaseLifeEducationPlan> rightCaseLifeEducationPlans,
                                        List<CaseLifeEducationPlan> stuCaseLifeEducationPlans, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseLifeEducationPlans != null && !rightCaseLifeEducationPlans.isEmpty())
                && (stuCaseLifeEducationPlans != null && !stuCaseLifeEducationPlans.isEmpty())) {
            CaseLifeEducationPlan stuCaseLifeEducationPlan = stuCaseLifeEducationPlans.get(0);
            CaseLifeEducationPlan caseLifeEducationPlan = rightCaseLifeEducationPlans.get(0);

            Map<String, java.util.function.Function<CaseLifeEducationPlan, String>> testCenters = new HashMap<>();
            testCenters.put("子女年龄", item -> convertToString(item.getChildAge()));
            testCenters.put("国内学费增长率", item -> convertToString(item.getInlandEduFee()));
            testCenters.put("国外学费增长率", item -> convertToString(item.getForeignEduFee()));
            testCenters.put("幼儿园教育-求学年龄", item -> convertToString(item.getaEduAge()));
            testCenters.put("幼儿园教育-求学时间", item -> convertToString(item.getaEduTime()));
            testCenters.put("幼儿园教育-目前学费", item -> convertToString(item.getaEduTuition()));
            testCenters.put("小学教育-求学年龄", item -> convertToString(item.getbEduAge()));
            testCenters.put("小学教育-求学时间", item -> convertToString(item.getbEduTime()));
            testCenters.put("小学教育-目前学费", item -> convertToString(item.getbEduTuition()));
            testCenters.put("初中教育-求学年龄", item -> convertToString(item.getcEduAge()));
            testCenters.put("初中教育-求学时间", item -> convertToString(item.getcEduTime()));
            testCenters.put("初中教育-目前学费", item -> convertToString(item.getcEduTuition()));
            testCenters.put("高中教育-求学年龄", item -> convertToString(item.getdEduAge()));
            testCenters.put("高中教育-求学时间", item -> convertToString(item.getdEduTime()));
            testCenters.put("高中教育-目前学费", item -> convertToString(item.getdEduTuition()));
            testCenters.put("大学教育-求学年龄", item -> convertToString(item.geteEduAge()));
            testCenters.put("大学教育-求学时间", item -> convertToString(item.geteEduTime()));
            testCenters.put("大学教育-目前学费", item -> convertToString(item.geteEduTuition()));
            testCenters.put("留学教育-求学年龄", item -> convertToString(item.getfEduAge()));
            testCenters.put("留学教育-求学时间", item -> convertToString(item.getfEduTime()));
            testCenters.put("留学教育-目前学费", item -> convertToString(item.getfEduTuition()));
            testCenters.put("商业保险", item -> convertToString(item.getInsurance()));
            testCenters.put("储蓄计划", item -> convertToString(item.getDeposit()));
            testCenters.put("其他安排", item -> convertToString(item.getOther()));
            testCenters.put("理财方案", item -> convertToString(item.getFinancialPlan()));
            testCenters.put("教育规划分析", CaseLifeEducationPlan::getAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseLifeEducationPlan, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseLifeEducationPlan, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseLifeEducationPlan));
                String stuScore = convertToString(scoreGetter.apply(stuCaseLifeEducationPlan));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("生涯规划-教育规划");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (testCenter.equals("理财方案") || testCenter.equals("教育规划分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }
    }

    private void caseCashPlans(String userId, String caseID, List<CaseCashPlan> rightCaseCashPlans,
                               List<CaseCashPlan> stuCaseCashPlans, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseCashPlans != null && !rightCaseCashPlans.isEmpty())
                && (stuCaseCashPlans != null && !stuCaseCashPlans.isEmpty())) {
            CaseCashPlan stuCaseCashPlan = stuCaseCashPlans.get(0);
            CaseCashPlan caseCashPlan = rightCaseCashPlans.get(0);

            Map<String, java.util.function.Function<CaseCashPlan, String>> testCenters = new HashMap<>();
            testCenters.put("家庭月支出", item -> convertToString(item.getFamilyMonthExpense()));
            testCenters.put("现金规划分析", CaseCashPlan::getAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseCashPlan, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseCashPlan, String> scoreGetter = entry.getValue();

                String caseScore = convertToString(scoreGetter.apply(caseCashPlan));
                String stuScore = convertToString(scoreGetter.apply(stuCaseCashPlan));

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("现金规划");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (testCenter.equals("现金规划分析")) {

                } else {
                    if (stuScore == null || !stuScore.equals(caseScore)) {
                        synthesisPlanScore.setStatus("答错");
                        synthesisPlanScore.setScore(BigDecimal.ZERO);
                    } else {
                        synthesisPlanScore.setStatus("答对");
                        synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                    }
                }
                list.add(synthesisPlanScore);
            }
        }
    }

    private String convertToString(Object obj) {
        if (obj instanceof BigDecimal) {
            return ((BigDecimal) obj).toString();
        } else {
            return obj != null ? obj.toString() : "";
        }
    }


    private void caseFinancialRatios(String userId, String
            caseID, List<CaseFinancialRatiosWithBLOBs> rightCaseFinancialRatiosWithBLOBs,
                                     List<CaseFinancialRatiosWithBLOBs> stuCaseFinancialRatiosWithBLOBs, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseFinancialRatiosWithBLOBs != null && !rightCaseFinancialRatiosWithBLOBs.isEmpty())
                && (stuCaseFinancialRatiosWithBLOBs != null && !stuCaseFinancialRatiosWithBLOBs.isEmpty())) {

            CaseFinancialRatiosWithBLOBs stuCaseFinancialRatiosWithBLOB = stuCaseFinancialRatiosWithBLOBs.get(0);
            CaseFinancialRatiosWithBLOBs caseFinancialRatiosWithBLOBs = rightCaseFinancialRatiosWithBLOBs.get(0);

            Map<String, java.util.function.Function<CaseFinancialRatiosWithBLOBs, String>> testCenters = new HashMap<>();
            testCenters.put("客户财务情况分析", CaseFinancialRatiosWithBLOBs::getAnalysis);

            for (Map.Entry<String, java.util.function.Function<CaseFinancialRatiosWithBLOBs, String>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseFinancialRatiosWithBLOBs, String> scoreGetter = entry.getValue();

                String caseScore = scoreGetter.apply(caseFinancialRatiosWithBLOBs);
                String stuScore = scoreGetter.apply(stuCaseFinancialRatiosWithBLOB);

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("财务分析-财务比例分析");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);
                list.add(synthesisPlanScore);
            }
        }
    }

    private void cashFlows(String userId, String
            caseID, List<CaseCashFlow> rightCashFlows, List<CaseCashFlow> stuCaseCashFlows,
                           List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCashFlows != null && !rightCashFlows.isEmpty())
                && (stuCaseCashFlows != null && !stuCaseCashFlows.isEmpty())) {

            CaseCashFlow stuCaseCashFlow = stuCaseCashFlows.get(0);
            CaseCashFlow caseCashFlow = rightCashFlows.get(0);

            Map<String, java.util.function.Function<CaseCashFlow, BigDecimal>> testCenters = new HashMap<>();
            testCenters.put("投资现金流量-投资赎回", CaseCashFlow::getRedemption);
            testCenters.put("投资现金流量-新增投资", CaseCashFlow::getInvestment);
            testCenters.put("借贷现金流量-借入本金", CaseCashFlow::getBorrowCapital);
            testCenters.put("借贷现金流量-还款本金", CaseCashFlow::getRepaymentCapital);

            for (Map.Entry<String, java.util.function.Function<CaseCashFlow, BigDecimal>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseCashFlow, BigDecimal> scoreGetter = entry.getValue();

                BigDecimal caseScore = scoreGetter.apply(caseCashFlow);
                BigDecimal stuScore = scoreGetter.apply(stuCaseCashFlow);

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("财务分析-收支储蓄表");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (stuScore == null || !stuScore.equals(caseScore)) {
                    synthesisPlanScore.setStatus("答错");
                    synthesisPlanScore.setScore(BigDecimal.ZERO);
                } else {
                    synthesisPlanScore.setStatus("答对");
                    synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                }

                list.add(synthesisPlanScore);
            }
        }
    }

    private void caseIncomeAndExpenses(String userId, String
            caseID, List<CaseIncomeAndExpenses> rightCaseIncomeAndExpenses,
                                       List<CaseIncomeAndExpenses> stuCaseIncomeAndExpenses, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((rightCaseIncomeAndExpenses != null && !rightCaseIncomeAndExpenses.isEmpty())
                && (stuCaseIncomeAndExpenses != null && !stuCaseIncomeAndExpenses.isEmpty())) {

            CaseIncomeAndExpenses stuCaseRiskIncomeAndExpenses = stuCaseIncomeAndExpenses.get(0);
            CaseIncomeAndExpenses caseIncomeAndExpenses = rightCaseIncomeAndExpenses.get(0);

            Map<String, java.util.function.Function<CaseIncomeAndExpenses, BigDecimal>> testCenters = new HashMap<>();
            testCenters.put("薪资收入", CaseIncomeAndExpenses::getJobIncome);
            testCenters.put("养老保险储蓄", CaseIncomeAndExpenses::getEndowmentInsurance);
            testCenters.put("医疗保险储蓄", CaseIncomeAndExpenses::getMedicalInsurance);
            testCenters.put("住房公积金储蓄", CaseIncomeAndExpenses::getHousingFund);
            testCenters.put("其他工作收入", CaseIncomeAndExpenses::getOtherJobIncome);
            testCenters.put("家计支出", CaseIncomeAndExpenses::getFamilyExpense);
            testCenters.put("子女教育支出", CaseIncomeAndExpenses::getChildExpense);
            testCenters.put("其他支出", CaseIncomeAndExpenses::getOtherExpense);
            testCenters.put("利息收入", CaseIncomeAndExpenses::getInterest);
            testCenters.put("资本利得", CaseIncomeAndExpenses::getCapitalGains);
            testCenters.put("其他理财收入", CaseIncomeAndExpenses::getOtherIncome);
            testCenters.put("利息支出", CaseIncomeAndExpenses::getInterestExpense);
            testCenters.put("保障型保费支出", CaseIncomeAndExpenses::getInsuranceExpense);
            testCenters.put("其他理财支出", CaseIncomeAndExpenses::getOtherFinanceExpense);

            for (Map.Entry<String, java.util.function.Function<CaseIncomeAndExpenses, BigDecimal>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseIncomeAndExpenses, BigDecimal> scoreGetter = entry.getValue();

                BigDecimal caseScore = scoreGetter.apply(caseIncomeAndExpenses);
                BigDecimal stuScore = scoreGetter.apply(stuCaseRiskIncomeAndExpenses);

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("财务分析-收支储蓄表");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (stuScore == null || !stuScore.equals(caseScore)) {
                    synthesisPlanScore.setStatus("答错");
                    synthesisPlanScore.setScore(BigDecimal.ZERO);
                } else {
                    synthesisPlanScore.setStatus("答对");
                    synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                }

                list.add(synthesisPlanScore);
            }
        }
    }


    private void caseFinanceLiabilities(String userId, String
            caseID, List<CaseFinanceLiability> rightCaseFinanceLiabilities,
                                        List<CaseFinanceLiability> stuCaseFinanceLiabilities, List<SynthesisPlanScoreWithBLOBs> list) {

        if ((rightCaseFinanceLiabilities != null && !rightCaseFinanceLiabilities.isEmpty())
                && (stuCaseFinanceLiabilities != null && !stuCaseFinanceLiabilities.isEmpty())) {

            CaseFinanceLiability stuCaseFinanceLiability = stuCaseFinanceLiabilities.get(0);
            CaseFinanceLiability caseFinanceLiability = rightCaseFinanceLiabilities.get(0);

            Map<String, java.util.function.Function<CaseFinanceLiability, BigDecimal>> testCenters = new HashMap<>();
            testCenters.put("现金", CaseFinanceLiability::getCash);
            testCenters.put("人民币银行活存", CaseFinanceLiability::getRmbDeposit);
            testCenters.put("其他流动资产", CaseFinanceLiability::getOtherAsset);
            testCenters.put("人民币银行定存", CaseFinanceLiability::getRmbFixedDeposit);
            testCenters.put("外币银行定存", CaseFinanceLiability::getForeignCurrencyFixedDeposit);
            testCenters.put("股票投资", CaseFinanceLiability::getStockInvestment);
            testCenters.put("债券投资", CaseFinanceLiability::getBondInvestment);
            testCenters.put("基金投资", CaseFinanceLiability::getFundInvestment);
            testCenters.put("实业投资", CaseFinanceLiability::getIndustryInvestment);
            testCenters.put("投资性房地产", CaseFinanceLiability::getEstateInvestment);
            testCenters.put("保单现金价值", CaseFinanceLiability::getPolicyInvestment);
            testCenters.put("其他投资性资产", CaseFinanceLiability::getOtherInvestment);
            testCenters.put("自用房地产", CaseFinanceLiability::getEstate);
            testCenters.put("自用汽车", CaseFinanceLiability::getCar);
            testCenters.put("自用其他资产", CaseFinanceLiability::getOthers);
            testCenters.put("信用卡负债", CaseFinanceLiability::getCreditCard);
            testCenters.put("小额消费信贷", CaseFinanceLiability::getMicrofinance);
            testCenters.put("其他消费性负债", CaseFinanceLiability::getOtherLoan);
            testCenters.put("金融投资借款", CaseFinanceLiability::getFinancialLoan);
            testCenters.put("实业投资借款", CaseFinanceLiability::getIndustryInvestmentLoan);
            testCenters.put("投资性房地产按揭贷款", CaseFinanceLiability::getEstateInvestmentLoan);
            testCenters.put("其他投资性负债", CaseFinanceLiability::getOtherInvestmentLoan);
            testCenters.put("自用房地产贷款", CaseFinanceLiability::getEstateLoan);
            testCenters.put("自用汽车贷款", CaseFinanceLiability::getCarLoan);
            testCenters.put("其他自用贷款", CaseFinanceLiability::getOthersLoan);

            for (Map.Entry<String, java.util.function.Function<CaseFinanceLiability, BigDecimal>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseFinanceLiability, BigDecimal> scoreGetter = entry.getValue();

                BigDecimal caseScore = scoreGetter.apply(caseFinanceLiability);
                BigDecimal stuScore = scoreGetter.apply(stuCaseFinanceLiability);

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("财务分析-资产负债表");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (stuScore == null || !stuScore.equals(caseScore)) {
                    synthesisPlanScore.setStatus("答错");
                    synthesisPlanScore.setScore(BigDecimal.ZERO);
                } else {
                    synthesisPlanScore.setStatus("答对");
                    synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                }
                list.add(synthesisPlanScore);
            }
        }
    }

    private void caseRiskIndex(String userId, String
            caseID, List<CaseRiskIndex> caseRiskIndices, List<CaseRiskIndex> stuCaseRiskIndices, List<SynthesisPlanScoreWithBLOBs> list) {
        if ((stuCaseRiskIndices != null && !stuCaseRiskIndices.isEmpty()) && (caseRiskIndices != null && !caseRiskIndices.isEmpty())) {
            CaseRiskIndex stuCaseRiskIndex = stuCaseRiskIndices.get(0);
            CaseRiskIndex caseRiskIndex = caseRiskIndices.get(0);

            Map<String, java.util.function.Function<CaseRiskIndex, BigDecimal>> testCenters = new HashMap<>();
            testCenters.put("客户得分-年龄", CaseRiskIndex::getAgeScore);
            testCenters.put("客户得分-就业状况", CaseRiskIndex::getJobScore);
            testCenters.put("客户得分-家庭负担", CaseRiskIndex::getFamilyScore);
            testCenters.put("客户得分-置产状况", CaseRiskIndex::getHouseScore);
            testCenters.put("客户得分-投资经验", CaseRiskIndex::getExpScore);
            testCenters.put("客户得分-投资知识", CaseRiskIndex::getKnowledgeScore);
            testCenters.put("客户得分-忍受亏损百分比", CaseRiskIndex::getTolerateScore);
            testCenters.put("客户得分-首要考虑", CaseRiskIndex::getConsiderationScore);
            testCenters.put("客户得分-认赔动作", CaseRiskIndex::getLossScore);
            testCenters.put("客户得分-赔钱心理", CaseRiskIndex::getMentalityScore);
            testCenters.put("客户得分-最重要特性", CaseRiskIndex::getCharacterScore);
            testCenters.put("客户得分-避免工具", CaseRiskIndex::getAvoidScore);

            for (Map.Entry<String, java.util.function.Function<CaseRiskIndex, BigDecimal>> entry : testCenters.entrySet()) {
                String testCenter = entry.getKey();
                java.util.function.Function<CaseRiskIndex, BigDecimal> scoreGetter = entry.getValue();

                BigDecimal caseScore = scoreGetter.apply(caseRiskIndex);
                BigDecimal stuScore = scoreGetter.apply(stuCaseRiskIndex);

                SynthesisPlanScoreWithBLOBs synthesisPlanScore = new SynthesisPlanScoreWithBLOBs();
                synthesisPlanScore.setSynthesisPlanId(IdUtil.randomUUID());
                synthesisPlanScore.setCaseid(caseID);
                synthesisPlanScore.setUserid(userId);
                synthesisPlanScore.setManageMoneyMattersType("风险测评-风险指标");
                synthesisPlanScore.setTestCenter(testCenter);
                // 检查并设置 caseAnswer 和 stuAnswer 字段
                synthesisPlanScore.setCaseAnswer(caseScore != null ? String.valueOf(caseScore) : null);
                synthesisPlanScore.setStuAnswer(stuScore != null ? String.valueOf(stuScore) : null);

                if (stuScore == null || !stuScore.equals(caseScore)) {
                    synthesisPlanScore.setStatus("答错");
                    synthesisPlanScore.setScore(BigDecimal.ZERO);
                } else {
                    synthesisPlanScore.setStatus("答对");
                    synthesisPlanScore.setScore(BigDecimal.valueOf(2));
                }

                list.add(synthesisPlanScore);
            }
        }
    }
}